//
//  DetailsCoordinator.swift
//  CoordinatorPatternDemo
//
//  Created by Malek Trabelsi on 16/01/2022.
//

import Foundation
import UIKit

public class DetailsCoordinator: Coordinator {
    var childCoordinators: [Coordinator] = []

    var dismissCoordinatorHandler: (() -> Void)?
    //1
    private let presentingViewController: UINavigationController

    init(presentingViewController: UINavigationController) {
        self.presentingViewController = presentingViewController
    }
    //2
    func start() {
        let detailsViewController = DetailsViewController()
        detailsViewController.dismissDetailsHandler = {[weak self] in
            self?.dismissCoordinatorHandler?()
        }
        presentingViewController.pushViewController(detailsViewController, animated: true)
    }
}
