//
//  HomeCoordinator.swift
//  CoordinatorPatternDemo
//
//  Created by Malek Trabelsi on 16/01/2022.
//

import Foundation
import UIKit

class HomeCoordinator: Coordinator {
    var childCoordinators: [Coordinator] = []
    //1
    private let window: UIWindow
    private let rootViewController: UINavigationController
    //2
    init(window: UIWindow) {
        self.window = window
        self.rootViewController = UINavigationController()
    }
    //3
    func start() {
        window.rootViewController = rootViewController
        let homeViewController = HomeViewController()
        homeViewController.moveToDetailsHandler = { [weak self] in
            guard let rootViewController = self?.rootViewController else {
                fatalError("rootViewController is nil")
            }
            let coordinator = DetailsCoordinator(presentingViewController: rootViewController)
            coordinator.dismissCoordinatorHandler = { [weak self] in
                guard let self = self else { return }

                self.childCoordinators = self.childCoordinators.filter({ $0 !== coordinator })
            }
            self?.childCoordinators.append(coordinator)
            coordinator.start()
        }
        rootViewController.pushViewController(homeViewController, animated: true)
        window.makeKeyAndVisible()
    }
}
